﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WinFormsClock {
	public partial class Form1 : Form {
		public Form1() {
			InitializeComponent();

			SetStyle(ControlStyles.ResizeRedraw, true);

			SetStyle(ControlStyles.AllPaintingInWmPaint
				| ControlStyles.OptimizedDoubleBuffer | ControlStyles.UserPaint, true);

			timer1_Tick(timer1, EventArgs.Empty);
		}

		private void timer1_Tick(object sender, EventArgs e) {
			var now = DateTime.Now;

			Text = now.ToString();
			Refresh();
		}

		protected override void OnPaint(PaintEventArgs e) {
			Graphics g = e.Graphics;

			g.TranslateTransform(ClientSize.Width / 2, ClientSize.Height / 2);
			g.ScaleTransform(ClientSize.Width / 400f, ClientSize.Height / 400f);

			var basicTransform = g.Transform;

			StringFormat sf = new StringFormat();
			sf.Alignment = StringAlignment.Center;

			Font f = new Font("Arial", 28);
			for (int i = 1; i <= 12; i++) {
				g.RotateTransform(360f / 12f);
				g.DrawString(i.ToString(), f, Brushes.Black, 0, -200, sf);
			}

			var now = DateTime.Now;

			g.RotateTransform((now.Hour / 12f) * 360f);
			Pen hourPen = new Pen(Color.Black, 20);
			g.DrawLine(hourPen, 0, 5, 0, -75);
			g.Transform = basicTransform;

			g.RotateTransform((now.Minute / 60f) * 360f);
			Pen minutePen = new Pen(Color.Black, 6);
			g.DrawLine(minutePen, 0, 5, 0, -150);
			g.Transform = basicTransform;

			g.RotateTransform((now.Second / 60f) * 360f);
			g.DrawLine(Pens.Black, 0, 5, 0, -150);
			g.DrawLine(Pens.Black, -8, -120, 0, -150);
			g.DrawLine(Pens.Black, 8, -120, 0, -150);
			g.DrawEllipse(Pens.Black, -8, 5, 16, 16);
			g.Transform = basicTransform;
		}
	}
}
